#include <stdio.h>
#include <stdint.h>

// Function to convert an int32_t to IEEE 754 single-precision hex
uint32_t intToIEEE754Hex(int32_t input) {
    // Define the sign bit, exponent, and mantissa parts
    uint32_t sign = (input < 0) ? 1 : 0;
    int32_t exponent = 0;
    uint32_t mantissa = 0;

    // inputs <= 0
    if (input == 0)
    {
        exponent = 0;
        mantissa = 0;
    }else
    {        
        if (input < 0)
        {
            input = -input;
            sign = 1;
        }
        
        int shift = 0;
        while ((input >> shift) >= 2)
        {
            shift++;
        }

        // exponent and mantissa
        exponent = shift + 127; // adding bias of 127
        mantissa = (input << (23 - shift)) & 0x007FFFFF;
    }

    // combine sign, exponent, and mantissa into the IEEE 754 format
    uint32_t ieee754 = ((uint32_t)sign << 31) | 
                       ((uint32_t)(exponent & 0xFF) << 23) | 
                       mantissa;
    
    return ieee754;
}

// test yo
int main() {
    int32_t input;
    printf("Exposure Time: ");
    scanf("%d", &input);
    
    printf("0x%08X\n", intToIEEE754Hex(input));

    return 0;
}